<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.security.Key" %>
<%@ page import="org.wso2.carbon.cep.stub.admin.internal.xsd.InputDTO" %>
<%@ page import="org.wso2.carbon.cep.stub.admin.internal.xsd.PropertyDTO" %>
<%@ page import="org.wso2.carbon.cep.stub.admin.internal.xsd.XpathDefinitionDTO" %>
<fmt:bundle basename="org.wso2.carbon.cep.ui.i18n.Resources">

<%
    String inputIndex = request.getParameter("index");
    int index = Integer.parseInt(inputIndex);
    InputDTO input = null;
    PropertyDTO[] properties = null;
    XpathDefinitionDTO[] xpathDefinitions = null;
    HashMap<Integer, InputDTO> inputHashMap = (HashMap<Integer, InputDTO>) session.getAttribute("inputsHashMap");
    HashMap<Integer, InputDTO> newInputHashMap = (HashMap<Integer, InputDTO>) session.getAttribute("newInputs");
    if (inputHashMap != null && inputHashMap.get(index) != null) {
        input = inputHashMap.get(index);
        properties = input.getMapping().getProperties();
        xpathDefinitions = input.getMapping().getXpathDefinition();
    } else if (newInputHashMap != null && newInputHashMap.get(index) != null) {
        input = newInputHashMap.get(index);
        properties = input.getMapping().getProperties();
        xpathDefinitions = input.getMapping().getXpathDefinition();

    }

    boolean isViewingBucket = false;
    String viewingBucket = request.getParameter("view");
    if(viewingBucket != null){
        isViewingBucket = true;
    }

%>
<div id="middle">
    <%--<img src="images/bucket_1.png" alt="Add input topics to bucket">--%>
    <h2><fmt:message key="inputs"/></h2>
    <div id="workArea">
        <table class="styledLeft" style="width:100%; margin-bottom:20px;">
            <thead>
            <%--<tr>--%>
                <th><fmt:message key="input"/></th>
            <%--</tr>--%>
            </thead>
            <tbody>
            <tr>
                <td class="formRaw">
                    <table class="normal">
                        <tbody>
                        <tr>
                            <td><fmt:message key="input.topic"/></td>
                            <td><input type="text" readonly="true" id="inputTopic" value="<%=input.getTopic()%>"></td>
                        </tr>
                        <tr>
                            <td><fmt:message key="broker.name"/></td>
                            <td><input type="text" readonly="true" id="inputBrokerName" value="<%=input.getBrokerName()%>"></td>
                        </tr>
                        </tbody>
                    </table>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <h5><fmt:message key="input.mapping.stream"/></h5>
                    <table>
                        <tbody>
                        <td><fmt:message key="stream"/></td>
                        <td><input type="text" readonly="true" id="mappingStream" value="<%=input.getMapping().getStream()%>"></td>
                        </tbody>
                    </table>
                     <h7 style= "line-height: 30px;"><fmt:message key="xpath_definition"/></h7>
                     <table class="styledLeft" id="xpathNamespacesTable" style="width:100%">
                        <thead>
                        <th class="leftCol-med"><fmt:message key="prefix"/></th>
                        <th class="leftCol-med"><fmt:message key="namespace"/></th>
                        </thead>
                         <tbody>
                          <% if(xpathDefinitions != null){
                              for(XpathDefinitionDTO xpathDefinition : xpathDefinitions){
                                  %>
                                  <tr>
                                      <td><%=xpathDefinition.getPrefix()%></td>
                                      <td><%=xpathDefinition.getNamespace()%></td>
                                  </tr>
                          <%
                              }
                          }
                          %>
                        </tbody>
                    </table>

                    <h7 style= "line-height: 30px;"><fmt:message key="property"/></h7>
                    <table class="styledLeft" id="propertyTable" style="width:100%">
                        <thead>
                            <th class="leftCol-med"><fmt:message key="property.name"/></th>
                            <th class="leftCol-med"><fmt:message key="property.xpath"/></th>
                            <th class="leftCol-med"><fmt:message key="property.type"/></th>
                        </thead>
                        <tbody>
                          <% if(properties != null){
                              for(PropertyDTO property : properties){
                                  %>
                                  <tr>
                                      <td><%=property.getName()%></td>
                                      <td><%=property.getXpath()%></td>
                                      <td><%=property.getType()%></td>
                                  </tr>
                          <%
                              }
                          }
                          %>
                        </tbody>
                    </table>
                </td>
            </tr>
            </tbody>

        </table>
        <table style="width:100%">
            <tbody>
            <tr>
                <td class="buttonRow">
                    <%
                        if(isViewingBucket){
                            %>
                    <input type="button" onclick="javascript:location.href='cep_view_bucket.jsp?edit=true'" value=" &lt;Back"class="button">
                            <%
                        }else{
                            %>
                    <input type="button" onclick="javascript:location.href='cep_buckets.jsp?edit=true'" value=" &lt;Back"class="button">
                            <%
                        }
                    %>
                </td>
            </tr>
            </tbody>
        </table>
    </div>
</div>
</fmt:bundle>